--[=====[
Rough emulation of the Action system in C#
An "action" is a set of fucntions that can run, accepting input (like delta time), returning nil
--]=====]

local class = require('Middleclass').class
--Event class, allows adding a list of functions and invoking all of them at once
local Action = class('Action')
function Action:add(funct) --add a function to be invoked
    if not self.events then
        self.events = {}
    end
    table.insert(self.events, funct)
end
function Action:run(...) --run all functions passing the arguments
    if self.events then
        for pos, funct in ipairs(self.events) do --convert to pairs
            funct(...)
        end
    end
end



return Action