--[=====[



--]=====]

local class = require('Middleclass').class
local Entity = require('ee_entity')

local Engine = class('Engine')




function Engine:initialize()
    print('starting Engine...')
    Engine.entities = {} --lists all spawned objects

end

function Engine:spawn(type, x, y, angle)
    local spawn = Entity(type,x,y,angle)
    spawn.engine = self
    table.insert(self.entities, spawn)
    return spawn
end

function Engine:update(dt)
    for _,entity in pairs(self.entities) do
        entity:update(dt)
    end

end

Engine.draw_lightpass = true
Engine.draw_non_lightpass = false

function Engine:draw()

    --THIS IS THE LIGHTDRAW PASS, it HAS to rotate inside the function (for some reason) 
    if self.draw_lightpass then
        love.graphics.push()

        -- love.graphics.translate(camera.x, camera.y) --What we have found here is ommiting these, the world scales in sync!
        -- love.graphics.scale(camera.scale)
        
        lightWorld:draw(function() --this is the lightworld pass

            love.graphics.rotate(camera.rotation)

            for _,entity in pairs(self.entities) do
                entity:lightdraw()
            end
        end)

        love.graphics.pop()
    end

    --THIS IS THE NON lightpass of the SAME THING as the light one (the actual scene graphics)
    if self.draw_non_lightpass then
        love.graphics.push()
        
        love.graphics.translate(camera.x, camera.y)
        love.graphics.scale(camera.scale)
        love.graphics.rotate(camera.rotation)

        for _,entity in pairs(self.entities) do
                entity:lightdraw()
        end
        love.graphics.pop()
    end


    --this is another draw pass, it is intended to be the GUI pass, in a final game, i would have this and lightworld passes only
    love.graphics.push()
    love.graphics.translate(camera.x, camera.y)
    love.graphics.scale(camera.scale)
    love.graphics.rotate(camera.rotation)

    for _,entity in pairs(self.entities) do
        entity:draw()
    end
    love.graphics.pop()

    


end





return Engine